/*
** Curve_3D.h
** 
** Made by damien
** Login   <damien@ortie.inrialpes.fr>
** 
** Started on  Wed Mar 26 16:22:43 2008 damien
** Last update Wed Mar 26 16:22:43 2008 damien
*/

#ifndef   	CURVE_3D_H_
# define   	CURVE_3D_H_

#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>
#include <vector>
using namespace std;

#include <V_3D.h>

class Curve_3D
{
 public:
  Curve_3D();
  Curve_3D(const Curve_3D& _curve);
  ~Curve_3D();

  int add_point(const V_3D& point);
  int size() const;
  int destroy();

  V_3D& get(int k_index);
  V_3D  get(int k_index) const;
  V_3D& operator[](int k_index);
  V_3D  operator[](int k_index) const;
  
  Curve_3D& operator=(const Curve_3D&);

 private:

  std::vector <V_3D> data;

};


#endif 	    /* !CURVE_3D_H_ */
