
#ifndef   	INT_VECTOR_H_
# define   	INT_VECTOR_H_

#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>

#include <vector>
using namespace std;

class int_vector
{
 public:
  int_vector();
  int_vector(const int_vector&);
  ~int_vector();

  int size() const;
  int resize(int _size);

  int &operator[](int k_vertex);
  int operator[](int k_vertex) const;
  int_vector& operator=(const int_vector&);

  int add_unique(int k_index);
  int add(int k_vertex);
  int add(std::vector <int>& _int_list);

 private:
  
  std::vector <int> int_list;
};


#endif 	    /* !INT_VECTOR_H_ */
